Require Export Arith.
Require Export claus_algo.

Definition EM :=
 (M:MD;L:(etL M);R:(relT M L);p:(prop M L))
  (E M L R p)\/~(E M L R p).

Definition AC :=
 (M:MD;L:(etL M);R:(relT M L);k:nat;dfp:(Dslct k M)->(skolT M)->(prop M L))
  ((x:(Dslct k M))(EX f:(skolT M)|(E M L R (dfp x f))))
   ->(EX F:(Dslct k M)->(skolT M)|(x:(Dslct k M))(E M L R (dfp x (F x)))).

(* AC_Prop := (S,S':Set;P:S->S'->Prop)
		((x:S)(EX y:S'|(P x y)))->(EXf:S->S'|(x:S)(P x (f x))) *)


Definition NED := [M:MD](k:nat)(Dslct k M).



(* extra facilities *)

Fixpoint ones [M:MD] : (etT M) :=
<[M:MD](etT M)> Cases M of 
  (md1 _)   =>  (1)
| (md2 _ m) => (1,(ones m))
end.

Fixpoint mkned' [a:Set;M:MD] : (arity' a M (0,(ones M)))->(NED (md2 a M)) :=
<[M:MD](arity' a M (0,(ones M)))->(NED (md2 a M))>
Cases M of
 (md1 b)   => [xy;k] let (x,y)=xy in
              <[k:nat](Dslct k (md2 a (md1 b)))>
              Cases k of
               (0) => x
              |(1) => y
              | _  => tt
              end
|(md2 b m) => [xys;k] let (x,ys)=xys in
              <[k:nat](Dslct k (md2 a (md2 b m)))>
              Cases k of
                O     => x
              |(S k') => (mkned' b m ys k')
              end
end.

Definition mkned :=
[M:MD]<[M:MD](arity M (ones M))->(NED M)>
Cases M of
 (md1 s)   => [a;k]<[n:nat](Dslct n (md1 s))>
              Cases k of O => a | _ => tt end
|(md2 s m) => (mkned' s m)
end.
