Require Export claus_algo.

Section CIF.

Variable M : MD.
Variable L : (etL M).
Variable Rel : (relT M L).
Local prp := (prop M L).
Local D2I:= (disj2impl M L Rel).
Local CHP := (chpol M L).
Local L2C := [L':(ne_list prp)](iE Rel (nel2conj M L L')).
(*Local C2L := [p:prp](iE Rel (conj2nel M L)).*)
Local MCIF := (cif M L D2I).
Local DCIF := (cif M L (iE Rel)).

Definition chpol_thm  : (p:prp)(iE Rel (CHP p))->~(iE Rel p) :=
[p:prp]<[p0:prp](iE Rel (CHP p0))->~(iE Rel p0)>
Cases p of
 (f_not q) => [h:(iE Rel q);h0:~(iE Rel q)](h0 h)
| q        => [h:~(iE Rel q)]h
end.

Fixpoint disj2impl_thm [p:prp] : (iE Rel p)->(D2I p) :=
<[p0:prp](iE Rel p0)->(D2I p0)>
Cases p of
 (f_or lit disj) => [h:(iE Rel lit)\/(iE Rel disj);h0:(iE Rel (CHP lit))]
                     (disj2impl_thm disj
                      (or_ind (iE Rel lit)(iE Rel disj)(iE Rel disj)
                       ([h1:(iE Rel lit)](absurd (iE Rel lit)(iE Rel disj) h1
                                      (chpol_thm lit h0)))
                       ([h2:(iE Rel disj)]h2)
                       h))
|(f_all k dp)    => [h:(x:(Dslct k M))(iE Rel (dp x));x:(Dslct k M)]
                    (disj2impl_thm (dp x)(h x))
| lit            => [h:(iE Rel lit);h0:(iE Rel (CHP lit))]
			(chpol_thm lit h0 h)
end.

Fixpoint mcif_thm [L':(ne_list prp)] : (MCIF L')->(L2C L')->False :=
<[l:(ne_list prp)](MCIF l)->~(L2C l)>
Cases L' of
 (sngl p)      => [h:(D2I p)->False;h0:(iE Rel p)](h (disj2impl_thm p h0))
|(ne_cons p t) => [h:(D2I p)->(MCIF t);h0:(iE Rel p)/\(L2C t)]
                  Cases h0 of (conj h1 h2) =>
                  (mcif_thm t (h (disj2impl_thm p h1)) h2) end
end.

Fixpoint dcif_thm [L':(ne_list prp)] : (DCIF L')->(L2C L')->False :=
<[l:(ne_list prp)](DCIF l)->~(L2C l)>
Cases L' of
 (sngl p)      => [h:(iE Rel p)->False;h0:(iE Rel p)](h h0)
|(ne_cons a t) => [h:(iE Rel a)->(DCIF t);h0:(iE Rel a)/\(L2C t)]
                  Cases h0 of (conj h1 h2) => (dcif_thm t (h h1) h2) end
end.

Local and_ass := 
[A,B,C:Prop;H:(A/\B/\C)]
 (and_ind A B/\C (A/\B)/\C
   [H0:A;H1:(B/\C)](and_ind B C (A/\B)/\C [H2:B; H3:C]
                    <(A/\B),C>{(<A,B>{H0,H2}),H3} H1) H).

End CIF.
