Require Export pnf_thm.
Require Export cnf_thm.
Require Export sklm_thm.
Require Export duqc_thm.
Require Export rb_thm.


Section DSCP.

Variable M   : MD.
Variable L   : (etL M).
Variable Rel : (relT M L).
Variable ac  : AC.
Variable ned : (NED M).

Local prp := (prop M L).

Local dumskol := [_,_,k:nat;z:(etT M);_:(sar M z)](ned k).

Remark dscp_remark :
(p:prp;i:nat)
 (iE Rel p)
  ->(EX f:(skolT M)|(iE Rel (nel2conj M L (dscp M L f ned i p)))).
Proof.
Intros p i H.
Unfold dscp.
Elim (sklm_thm1 M L Rel ned ac i (cnf M L (pnf M L p))).
Intros f H0.
Exists f.
Apply (duqc_thm1 M L Rel ned
        (rb M L (sklm M L f i (cnf M L (pnf M L p))))).
Apply rb_thm1.
Exact H0.
Apply cnf_thm1.
Apply pnf_thm1.
Exact ned.
Exact H.
Qed.

Remark sklm_conj_index_eeq :
 (p:prp;f,g:(skolT M);i,i',j:nat;z:(etT M);vs:(sar M z))
  (f i)=(g i')
   ->(iE Rel (sklm_rec M L f i j z vs p))
    ->(iE Rel (sklm_rec M L g i' j z vs p)).
Proof.
Induction p; Trivial.
Intros k p' IH f g i i' j z vs H H0.
Apply (IH (g i' j k z vs) f g i i' (S j) z vs H).
Rewrite <- H.
Exact H0.
Simpl. Intros k p' IH f g i i' j z vs H H0 x.
Exact (IH x f g i i' j (S_nth_exp M k z)(insertb M k x z vs) H (H0 x)).
Qed.

Remark dscp_eeq :
 (p:prp;f,g:(skolT M);i,i':nat)
  (f i)=(g i')
   ->(iE Rel (nel2conj M L (dscp M L f ned i p)))
    ->(iE Rel (nel2conj M L (dscp M L g ned i' p))).
Proof.
Intros p f g i i' H H0.
Unfold dscp.
Apply duqc_thm1.
Apply rb_thm1.
Apply (sklm_conj_index_eeq (cnf M L (pnf M L p))
	f g i i' (0)(zeroes M)(mktt M) H).
Apply rb_thm2.
Apply (duqc_thm2 M L Rel ned).
Exact H0.
Qed.

Remark dscp_rec_eeq :
 (L':(ne_list prp);f,g:(skolT M);i:nat)
 ((n:nat)(f n)=(g (S n)))
  ->(iE Rel (nel2conj M L (dscp_rec M L f ned i L')))
   ->(iE Rel (nel2conj M L (dscp_rec M L g ned (S i) L'))).
Proof.
Induction L'.
Intros p f g i H H0.
Apply (dscp_eeq p f g i (S i)). Apply H. Exact H0.
Intros p t IH f g i H H0.
Elim (app2and M L Rel (dscp M L f ned i p) (dscp_rec M L f ned (S i) t) H0).
Intros H1 H2. 
Simpl. Apply and2app. Split.
Apply (dscp_eeq p f g i (S i)). Apply H. Exact H1.
Exact (IH f g (S i) H H2).
Qed.

Theorem dscp_thm :
(L':(ne_list prp))
 (iE Rel (nel2conj M L L'))
  ->(EX f:(skolT M)|(iE Rel (nel2conj M L (dscp_rec M L f ned O L')))).
Proof.
Induction L'.
Intros p H. Elim (dscp_remark p O H). Intros f H0. Exists f. Exact H0.
Intros p t IH H. Elim H. Intros H1 H2.
Elim (dscp_remark p O H1). Intros f H3.
Elim (IH H2).Intros g H4.
Exists [i]Cases i of O => (f O) |(S i') => (g i') end.
Simpl. Apply and2app. Split.
Apply (dscp_eeq p f [i]Cases i of O => (f O) |(S i') => (g i') end O O).
Reflexivity. Exact H3.
Apply (dscp_rec_eeq t g [i]Cases i of O => (f O) |(S i') => (g i') end).
Intro n. Reflexivity.
Exact H4.
Qed.

End DSCP.
