Require Export axiom_types.

Section DUQC.

Variable M   : MD.
Variable L   : (etL M).
Variable Rel : (relT M L).
Variable ned : (NED M).

Local prp := (prop M L).

Remark duqc1_remark1 : (p:prp)(iE Rel p)->(iE Rel (duqc1 M L p)).
Proof.
Induction p; Trivial.
Intros p1 IH1 p2 IH2 H. Elim H. Intros H1 H2. Exact H1.
Simpl. Intros k p' IH H x. Exact (IH x (H x)).
Qed.

Remark duqc2_remark1 : (p:prp)(iE Rel p)->(iE Rel (duqc2 M L p)).
Proof.
Induction p; Trivial.
Intros p1 IH1 p2 IH2 H. Elim H. Intros H1 H2. Exact H2.
Simpl. Intros k p' IH H x. Exact (IH x (H x)).
Qed.

Remark duqc12_remark :
 (p:prp)(iE Rel (duqc1 M L p))->(iE Rel (duqc2 M L p))->(iE Rel p).
Proof.
Induction p; Trivial.
Intros p1 IH1 p2 IH2 H H0. 
Split. Exact H. Exact H0.
Simpl. Intros k p' IH H H0 x. 
Exact (IH x (H x)(H0 x)).
Qed.

Remark duqc_remark1 :
 (n:nat;p:prp)(iE Rel p)->(iE Rel (nel2conj M L (duqc_rec M L p n))).
Proof.
Induction n.
Trivial.
Intros n' IHn. Destruct p.
Intros i t H. Split. Exact H. Apply IHn. Exact H.
Intros p0 H. Split. Exact H. Apply IHn. Exact H.
Intros p1 p2 H. Elim H. Intros H1 H2. Split. Exact H1. Apply IHn. Exact H2.
Intros p1 p2 H. Split. Exact H. Apply IHn. Exact H.
Intros p1 p2 H. Split. Exact H. Apply IHn. Exact H.
Intros k p' H. Split. Exact H. Apply IHn. Exact H.
Intros k p' H. Split. Apply duqc1_remark1. Exact H.
 Apply IHn. Apply duqc2_remark1. Exact H.
Qed.

Remark duqc_remark2 :
 (n:nat;p:prp)(iE Rel (nel2conj M L (duqc_rec M L p n)))->(iE Rel p).
Proof.
Induction n.
Trivial.
Intros n' IHn. Destruct p.
Intros i t H. Elim H. Intros H1 H2. Exact H1.
Intros p0 H. Elim H. Intros H1 H2. Exact H1.
Intros p1 p2 H. Elim H. Intros H1 H2. Split. Exact H1. Apply IHn. Exact H2.
Intros p1 p2 H. Elim H. Intros H1 H2. Exact H1.
Intros p1 p2 H. Elim H. Intros H1 H2. Exact H1.
Intros k p' H. Elim H. Intros H1 H2. Exact H1.
Intros k p' H. Elim H. Intros H1 H2.
Apply duqc12_remark. Exact H1. Apply IHn. Exact H2.
Qed.

Theorem duqc_thm1 : (p:prp)(iE Rel p)->(iE Rel (nel2conj M L (duqc M L ned p))).
Proof.
Destruct p; Trivial.
Intros k p' H.
Simpl. Apply (duqc_remark1 (cdepth M L ned (p' (ned k)))).
Exact H.
Qed.

Theorem duqc_thm2 : (p:prp)(iE Rel (nel2conj M L (duqc M L ned p)))->(iE Rel p).
Proof.
Destruct p; Trivial.
Intros k p' H.
Apply (duqc_remark2 (cdepth M L ned (p' (ned k)))).
Exact H.
Qed.

End DUQC.
