Require Export sklm_support.

Lemma beq0 :
 (s:Set;e:nat;selts:(pow' s e);P:(n:nat)(pow' s n)->Prop)
  (P e selts)<->(P (plus e O)(prod_app' s e selts O tt)).
Proof.
Induction e.
(* e = O *)
Intros. Apply piffp.
(* e = (S e') *)
Intros e' IH selts P.
Case selts.
Intros x selts'.
Exact (IH selts' [n:nat;brrr:(pow' s n)](P (S n) (x,brrr))).
Qed.

Lemma beq1 :
 (M:MD;z:(etT M);elts:(sar M z);P:(z:(etT M))(sar M z)->Prop)
  (P z elts)
   <->
   (P (etplus M (zeroes M) z)(insertf_tuple M (zeroes M)(mktt M) z elts)).
Proof.
Induction M.
Intros. Apply piffp.
Intros s m IH z.
Case z. Intros e z'.
Case e.
Intros melts P.
Exact (IH z' melts [z:(etT m)](P (O,z))).
Intros e' elts.
Case elts.
Intros selts melts P.
Exact (IH z' melts [z:(etT m);elts:(sar m z)](P ((S e'),z) (selts,elts))).
Qed.

Lemma beq2 :
 (M:MD;z:(etT M);elts:(sar M z);P:(z:(etT M))(sar M z)->Prop)
  (P z elts)
   <->(P (etplus M z (zeroes M))(insertf_tuple M z elts (zeroes M)(mktt M))).
Proof.
Induction M.
(* M = (md1 s) *)
Intros s e. Case e.
Intros t P. Case t. Apply piffp.
Intros e'. Elim e'.
Intros x p. Apply piffp.
Intros e'' IH selts P. Case selts.
Intros x selts'.
Exact (IH selts'
        [n:nat]<[n:nat](pow s n)->Prop>
		Cases n of
		   O     => [_:unit]False
		| (S n') => [selts:(pow' s n')](P (S(S n'))(x,selts))
		end).
(* M = (md2 s m) *)
Intros s m IH z.
Case z. Intros e z'. (* z = (e,z') *)
Case e.
(* e = O *)
Intros melts P.
Exact (IH z' melts [u:(etT m)][melts:(sar m u)](P (O,u) melts)).
(* e = (S e') *)
Intros e' elts P. Case elts. Intros selts melts. (* elts = (selts,melts) *)
(* see \Coq\msl\obs *)
Split; Intro H.
(* -> *)
Apply
 (proj1 ? ?
  (IH z' melts
   [u:(etT m);brrr:(sar m u)]
    (P ((S(plus e' O)),u)((prod_app' s e' selts O tt),brrr)))).
Exact
 (proj1 ? ?
  (beq0 s e' selts
   [n:nat;q:(pow' s n)](P ((S n),z')(q,melts))) H).
(* <- *)
Apply
 (proj2 ? ?
  (beq0 s e' selts [n:nat;q:(pow' s n)](P ((S n),z')(q,melts)))).
Exact
 (proj2 ? ?
  (IH z' melts 
   [u:(etT m);brrr:(sar m u)]
    (P ((S(plus e' O)),u)((prod_app' s e' selts O tt),brrr))) H).
Qed.

Lemma beq3 :
 (M:MD;u,v:(etT M);uelts:(sar M u);velts:(sar M v))
  (P:(z:(etT M))(sar M z)->Prop;k:nat;x:(Dslct k M))
   (P (etplus M (S_nth_exp M k u) v)
      (insertf_tuple M (S_nth_exp M k u)(insertb M k x u uelts) v velts))
   <->
   (P (etplus M u (S_nth_exp M k v))
      (insertf_tuple M u uelts (S_nth_exp M k v)(insertf M k x v velts))).
Proof.
Induction M.
(* M = (md1 s) *)
Intros s eu.
Case eu.
(* eu = O *)
Intros v uelts velts P k. Case k;Intros;Apply piffp.
(* eu = (S eu') *)
Intro eu'. Elim eu'.
(* eu' = O *)
Intros v uelts velts P k. Case k;Intros;Apply piffp.
(* eu' = (S eu2) *)
Intros eu2 IHeu2 v uelts velts P k.
Case uelts.
Intros y uelts'.
Case k.
(* k = O *)
Intro x.
Exact (IHeu2 v uelts' velts [n:nat]
		<[n:nat](pow s n)->Prop>
		Cases n of
		   O     => [_:unit]False
		| (S n') => [selts:(pow' s n')](P (S(S n'))(y,selts))
		end
		O x).
(* k = (S k') *)
Intros;Apply piffp.
(* M = (md2 s m) *)
Intros s m IHm u.
Case u. (* u = (eu,u') *) Intros eu u' v.
Case v. (* v = (eu,v') *) Intros ev v'.
Case eu.
(* eu = O *)
Intro umelts.
Case ev.
(* ev = O *)
Intros vmelts P k.
Case k.
(* k = O *)
Intros;Apply piffp.
(* k = (S k') *)
Intros k' x.
Exact (IHm u' v' umelts vmelts [z:(etT m);melts:(sar m z)](P (O,z) melts) k' x).
(* ev = (S ev') *)
Intros ev' velts.
Case velts. (* velts = (vselts,vmelts) *)
Intros vselts vmelts P k.
Case k.
(* k = O *)
Intros;Apply piffp.
(* k = (S k') *)
Intros k' x.
Exact (IHm u' v' umelts vmelts
	[z:(etT m);melts:(sar m z)](P ((S ev'),z)(vselts,melts)) k' x).
Intros eu'.
Elim eu'.
(* eu' = O *)
Intro uelts.
Case uelts. (* uelts = (uselts,umelts) *)
Intros uselts umelts.
Case ev.
(* ev = O *)
Intros vmelts P k.
Case k.
(* k = O *)
Intros;Apply piffp.
(* k = (S k') *)
Intros k' x.
Exact (IHm u' v' umelts vmelts
        [z:(etT m)][melts:(sar m z)](P ((S O),z) (uselts,melts)) k' x).
(* ev = (S ev') *)
Intros ev' velts P k.
Case velts.(* velts = (vselts,vmelts) *)
Intros vselts vmelts.
Case k.
(* k = O *)
Intros;Apply piffp.
(* k = (S k') *)
Intros k' x.
Exact (IHm u' v' umelts vmelts
        [z:(etT m)]
         [melts:(sar m z)](P ((S (S ev')),z) ((uselts,vselts),melts)) k' x).
(* eu' = (S eu2) *)
Intros eu2 IHeu2 uelts.
Case uelts. (* uelts = (uselts,umelts) *)
Intros uselts umelts.
Case uselts. (* uselts = (a,uselts') *)
Intros a uselts'.
Generalize IHeu2.
Case ev.
(* ev = O *)
Intros IHeu20 vmelts P k.
Case k.
(* k = O *)
Exact (IHeu20 (uselts',umelts) vmelts
	[z:nat*(etT m)]
	<[z:nat*(etT m)](sar (md2 s m) z)->Prop>
	let (e,z') = z in
	<[n:nat](sar (md2 s m) (n,z'))->Prop>
	Cases e of
	  O     => [melts:(sar m z')]False
	|(S e') => [elts:(pow' s e')*(sar m z')]
		   let (selts,melts)=elts in
		   (P ((S(S e')),z')((a,selts),(melts)))
	end O).
(* k = (S k') *)
Intro k'.
Exact (IHeu20 (uselts',umelts) vmelts
	[z:nat*(etT m)]
	<[z:nat*(etT m)](sar (md2 s m) z)->Prop>
	let (e,z') = z in
	<[n:nat](sar (md2 s m) (n,z'))->Prop>
	Cases e of
	  O     => [melts:(sar m z')]False
	|(S e') => [elts:(pow' s e')*(sar m z')]
		   let (selts,melts)=elts in
		   (P ((S(S e')),z')((a,selts),(melts)))
	end (S k')).
(* ev = (S ev') *)
Intros ev' IHeu2ev' velts P k.
Case velts.
Intros vselts vmelts.
Case k.
(* k = O *)
Exact (IHeu2ev' (uselts',umelts)(vselts,vmelts)
 [z:nat*(etT m)]
 <[z:nat*(etT m)](sar (md2 s m) z)->Prop>
 let (e,z')=z in
 <[e:nat](sar (md2 s m)(e,z'))->Prop>
 Cases e of
    O     => [melts:(sar m z')]False
 | (S e') => [elts:(pow' s e')*(sar m z')]
	     let (selts,melts)=elts in
	     (P ((S(S e')),z')((a,selts),melts))
 end O).
(* k = (S k') *)
Intro k'.
Exact (IHeu2ev' (uselts',umelts)(vselts,vmelts)
 [z:nat*(etT m)]
 <[z:nat*(etT m)](sar (md2 s m) z)->Prop>
 let (e,z')=z in
 <[e:nat](sar (md2 s m)(e,z'))->Prop>
 Cases e of
    O     => [melts:(sar m z')]False
 | (S e') => [elts:(pow' s e')*(sar m z')]
	     let (selts,melts)=elts in
	     (P ((S(S e')),z')((a,selts),melts))
 end (S k')).
Qed.

Lemma sklm_eeqfg :
(M:MD;L:(etL M);R:(relT M L);f,g:(skolT M);p:(prop M L);i,nf,ng:nat)
 (zf,zg:(etT M);eltsf:(sar M zf);eltsg:(sar M zg))
   ((m,k:nat;z:(etT M);elts:(sar M z))
    (f i (plus nf m) k (etplus M zf z)(insertf_tuple M zf eltsf z elts))
     =(g i (plus ng m) k (etplus M zg z)(insertf_tuple M zg eltsg z elts)))
    ->(E M L R (sklm_rec M L f i nf zf eltsf p))
     ->(E M L R (sklm_rec M L g i ng zg eltsg p)).
Proof.
Intros M L R f g.
(Induction p; Trivial).
(* EX *)
Intros k dp IH i nf ng zf zg eltsf eltsg f_eeq_g H.
Apply (IH (g i ng k zg eltsg) i (S nf)(S ng) zf zg eltsf eltsg).
Intro m.
Rewrite (plus_Snm_nSm nf m).
Rewrite (plus_Snm_nSm ng m).
Exact (f_eeq_g (S m)).
Replace (g i ng k zg eltsg) with (f i nf k zf eltsf).
Exact H.
Replace (g i ng k zg eltsg) with
 (g i ng k (etplus M zg (zeroes M))
   (insertf_tuple M zg eltsg (zeroes M) (mktt M))).
Replace (f i nf k zf eltsf) with
 (f i nf k (etplus M zf (zeroes M))
   (insertf_tuple M zf eltsf (zeroes M) (mktt M))).
Rewrite (plus_n_O nf).
Rewrite (plus_n_O ng).
Exact (f_eeq_g O k (zeroes M)(mktt M)).
Symmetry.
Exact
 (proj1 ? ?
  (beq2 M zf eltsf
   [u:(etT M);brrr:(sar M u)](f i nf k zf eltsf)=(f i nf k u brrr))
    (refl_equal (Dslct k M) (f i nf k zf eltsf))).
Symmetry.
Exact
 (proj1 ? ?
  (beq2 M zg eltsg
   [u:(etT M);brrr:(sar M u)](g i ng k zg eltsg)=(g i ng k u brrr))
    (refl_equal (Dslct k M) (g i ng k zg eltsg))).
(* ALL *)
Simpl. Intros k dp IH i nf ng zf zg eltsf eltsg f_eeq_g H x.
Apply (IH x i nf ng (S_nth_exp M k zf) (S_nth_exp M k zg)
	(insertb M k x zf eltsf)(insertb M k x zg eltsg)).
Intros m n z elts.
Replace (f i (plus nf m) n (etplus M (S_nth_exp M k zf) z)
          (insertf_tuple M (S_nth_exp M k zf)(insertb M k x zf eltsf) z elts))
   with (f i (plus nf m) n (etplus M zf (S_nth_exp M k z))
          (insertf_tuple M zf eltsf (S_nth_exp M k z)(insertf M k x z elts))).
Replace (g i (plus ng m) n (etplus M (S_nth_exp M k zg) z)
          (insertf_tuple M (S_nth_exp M k zg)(insertb M k x zg eltsg) z elts))
   with (g i (plus ng m) n (etplus M zg (S_nth_exp M k z))
          (insertf_tuple M zg eltsg (S_nth_exp M k z)(insertf M k x z elts))).
Exact (f_eeq_g m n (S_nth_exp M k z) (insertf M k x z elts)).
Apply
 (proj2 ? ?
  (beq3 M zg z eltsg elts
   [u:(etT M);bb:(sar M u)]
    (g i (plus ng m) n
	 (etplus M zg (S_nth_exp M k z))
	 (insertf_tuple M zg eltsg (S_nth_exp M k z)(insertf M k x z elts)))
    =
    (g i (plus ng m) n u bb) k x)).
Reflexivity.
Apply
 (proj2 ? ?
  (beq3 M zf z eltsf elts
   [u:(etT M);bb:(sar M u)]
    (f i (plus nf m) n
	 (etplus M zf (S_nth_exp M k z))
	 (insertf_tuple M zf eltsf (S_nth_exp M k z)(insertf M k x z elts)))
    =
    (f i (plus nf m) n u bb) k x)).
Reflexivity.
Exact (H x).
Qed.

Lemma beq4 :
(M:MD;k:nat;x:(Dslct k M);z:(etT M);elts:(sar M z))
 (P:(u:(etT M))(sar M u)->Prop) 
  (P (etplus M (S_nth_exp M k (zeroes M)) z)
     (insertf_tuple M (S_nth_exp M k (zeroes M))
       (insertb M k x (zeroes M) (mktt M)) z elts))
  <->(P (S_nth_exp M k (etplus M (zeroes M) z))
        (insertf M k x (etplus M (zeroes M) z)
         (insertf_tuple M (zeroes M) (mktt M) z elts))).
Proof.
Induction M.
(* M = (md1 s) *)
Intros s k.
Case k; Intros;Apply piffp.
(* M = (md2 s m) *)
Intros s m IH k.
Case k.
(* k = O *)
Intros x z.
Case z. Intros e z'.
Case e.
Intros;Apply piffp.
Intros e' elts.
Case elts. Intros selts melts P.
Intros;Apply piffp.
(* k = (S k') *)
Intros k' x z.
Case z. Intros e z'.
Case e.
Intros melts P.
Exact (IH k' x z' melts [u:(etT m)][a:(sar m u)](P (O,u) a)).
Intros e' elts P.
Case elts. Intros selts melts.
Exact (IH k' x z' melts [u:(etT m);a:(sar m u)](P ((S e'),u)(selts,a))).
Qed.

Lemma unit0 : (t,u:unit)t=u.
Intros t u. Case t. Case u. Reflexivity. Qed.
Hints Resolve unit0 : v62.

Lemma x_if_eqab_corr :
 (M:MD;ned:(NED M);k:nat;x:(Dslct k M))x=(x_if_eqab M ned k k x).
Proof.
Induction M.
Intros s ned k. Case k. Trivial with v62. Intros k' x. Case x.
Trivial with v62.
Intros s m IH ned k. Case k. Trivial with v62. Exact (IH [n:nat](ned (S n))).
Qed.

Lemma nfu0 :
 (M:MD;z:(etT M);elts:(sar M z);k:nat;d,x:(Dslct k M))
  (nth_fst_elt M k d
   (etplus M (S_nth_exp M k (zeroes M)) z)
   (insertf_tuple M (S_nth_exp M k (zeroes M))
    (insertb M k x (zeroes M)(mktt M)) z elts))
  = x.
Proof.
Induction M.
Intros s e. Case e; Intros until k; Case k; Trivial with v62.
Intros s m IH z.
Case z. Intros e z'.
Case e.
Intros melts k. Case k. Trivial with v62. Exact (IH z' melts).
Intros e' elts.
Case elts. Intros selts melts k.
Case k. Trivial with v62. Exact (IH z' melts).
Qed.

Lemma beq5 :
 (M:MD;z:(etT M);elts:(sar M z);P:(z:(etT M))(sar M z)->Prop)
  (k:nat;x:(Dslct k M))
  (P z elts)
   <->(P (pred_nth_exp M k (etplus M (S_nth_exp M k (zeroes M)) z))
	 (rm_nth_fst_elt M k (etplus M (S_nth_exp M k (zeroes M)) z)
	  (insertf_tuple M (S_nth_exp M k (zeroes M))
		       (insertb M k x (zeroes M)(mktt M)) z elts))).
Proof.
Induction M.
(* M = (md1 s) *)
Intros s e. Case e.
(* e = O *)
Intros t P k. Case t.
Case k; Intros;Apply piffp.
(* e = (S e') *)
Intros e' selts P k.
Case k; Intros;Apply piffp.
(* M = (md2 s m) *)
Intros s m IH z.
Case z. Intros e z'.
Case e.
(* e = O *)
Intros melts P k.
Case k.
Intro x.
Exact (beq1 m z' melts [z:(etT m)](P (O,z))).
Exact (IH z' melts [z:(etT m)](P (O,z))).
Intros e' elts.
Case elts.
Intros selts melts P k.
Case k.
Intro x.
Exact (beq1 m z' melts
        [z:(etT m)][elts:(sar m z)](P ((S e'),z) (selts,elts))).
Exact (IH z' melts [z:(etT m)][elts:(sar m z)](P ((S e'),z) (selts,elts))).
Qed.



