Require Export MSL.

(* Parsing *)

Grammar command command2 :=
   neg [ "!~" command2($p) ] -> [<<(f_Not $p)>>]

with command6 :=
   cnj [ command5($p) "!/\\" command6($q) ] -> [<<(f_And $p $q)>>]

with command7 :=
   dsj [ command6($p) "!\\/" command7($q) ] -> [<<(f_Or $p $q)>>]

with command8 :=
   imp [ command7($p) "!->" command8($q) ] -> [<<(f_Impl $p $q)>>]

 | bim [ command7($p) "!<->" command8($q) ] -> [<<(f_Iff $p $q)>>]

with command10 :=
   exq [ "!EX" command($n) ident($x) ":" command($t) "|" command($p) ] 
	-> [<<(f_Ex $n [$x:$t]$p)>>]
 | uvq [ "!ALL" command($n) ident($x) ":" command($t) "|" command($p) ] 
	-> [<<(f_All $n [$x:$t]$p)>>].


(* Pretty printing *)

Syntax constr
 level 2:
   neg [<<(f_not $_ $_ $p)>>]    -> [[<hov 0> "!~" $p:E ]];

 level 6:
   cnj [<<(f_and $_ $_ $p $q)>>]  -> [[<hov 0> $p:L [0 0] " !/\\ " $q:E ]];

 level 7:
   dsj [<<(f_or $_ $_ $p $q)>>]   -> [[<hov 0> $p:L [0 0] " !\\/ " $q:E ]];

 level 8:
   imp [<<(f_impl $_ $_ $p $q)>>] -> [[<hov 0> $p:L [0 0] " !-> " $q:E ]]

 | bim [<<(f_iff $_ $_ $p $q)>>] -> [[<hov 0> $p:L [0 0] " !<-> " $q:E ]];

 level 10:
   exq [<<(f_ex $_ $_ $n [$x:$t]$p)>>] 
	-> [[<hov 3> "!EX(" $n ") " $x " |" [1 0] $p ]]
 | uvq [<<(f_all $_ $_ $n [$x:$t]$p)>>]
	-> [[<hov 3> "!ALL(" $n ") " $x " |" [1 0] $p ]].



(* Note that, in this case, Coq cannot parse its own output.
   If you want in- and output to be compatible, use milk.v .
*)
