Require Export CLAUS.

Section Sample.

Variable A : Set.

Local M := (md1 A).

Variable P : A->Prop.
Variable R : A*A->Prop.

Local L := (ne_cons (1)(sngl (2))).

Local REL : (relT M L) :=
[i]<[i:nat](ar_slct M L i)->Prop>Cases i of O => P | _ => R end.

Local f_p := (f_atom M L (0)).
Local f_r := (f_atom M L (1)).

Variable em : EM.
Variable ac : AC.
Variable  a : A.

Local ned := (mkned M a).

Local f_Rserial := (f_All (0)[x:A](f_Ex (0)[y:A](f_r (x,y)))).

Local f_Rtrans :=
(f_All (0)[x:A]
 (f_All (0)[y:A]
  (f_All (0)[z:A]
   (f_Impl
    (f_r (x,y))
    (f_Impl (f_r (y,z))(f_r (x,z))))))).

Local f_stat :=
(f_Not
 (f_All (0)[x:A]
  (f_Iff
   (f_All (0)[y:A](f_Impl (f_r (x,y))(f_Not (f_p y))))
    (f_p x)))).

Local f_HB := (f_Impl f_Rserial (f_Impl f_Rtrans f_stat)).

Local f1 := [skol:(skolT M)](skol (0)(0)(0)(1)).
Local f2 := [skol:(skolT M)](skol (2)(0)(0)(1)).

Lemma HB : (E M L REL f_HB).
Proof.
Apply (mcf REL em ac ned f_HB).
Time Lazy Beta Delta -[skolT] Iota.
Intro skol.
Intros C1 C2 C3 C4 C5.
Exact        
(
([C349:(x:A)(P x)->False]
((* BEGIN C357 *)
[x:A][h:((P x)->False)]
(C4 x a (C349 (f2 skol x)) h) 
(* END C357 *) 
a (C349 a)))
(* BEGIN C349 *)
[x:A][h:(P x)] ((* BEGIN C323 *)
[x:A][h:(P (f1 skol x))->False][h1:(P x)]
(C1 x [h2:(R (x,(f1 skol x)))] ((* BEGIN C296 *)
[x,y:A][h:((P x)->False)][h1:(R (y,x))]
[h2:(P y)]  ((* BEGIN C15 *)
[x,y:A][h:((P x)->False)][h1:(R (y,x))]
[h2:(R (y,(f2 skol x)))->False]
(C3 x a ([h3:(R (x,(f2 skol x)))]
(C2 y x (f2 skol x) h1 h3 h2)) h) (*  END C15 *)
x y h h1 [h3:(R (y,(f2 skol x)))] ((* BEGIN C9 *)
[x,y:A][h:(R (x,(f2 skol y)))][h1:(P x)][h2:((P y)->False)]
(C4 y a [h3:(P (f2 skol y))](C5 x (f2 skol y)
h1 h h3) h2) (* END C9 *) y x h3 h2 h)) (* END C296 *)
(f1 skol x) x h h2 h1)) (* END C323 *)
x [h1:(P (f1 skol x))] ((* BEGIN C7 *)
[x:A][h:(P (f1 skol x))][h1:(P x)]
(C1 x [h2:(R (x,(f1 skol x)))](C5 x (f1 skol x)
h1 h2 h)) (* END C7 *)
x  h1 h) h)
(* END C349 *)
).

Qed.

End Sample.
