Require sugarCLAUS.

Section Sample.

Variables A,B : Set.

Local M := (md2 B (md1 A)).

Variable P : A->Prop.
Variable Q : B->Prop.

Local L := (ne_cons (1,0) (sngl (0,1))).

Local REL : (relT M L) :=
	[i]<[i:nat](ar_slct M L i)->Prop>
	Cases i of
	  O => Q
	| _ => P end.

Local f_q := (f_atom M L (0)).
Local f_p := (f_atom M L (1)).

Variable em : EM.
Variable ac : AC.
Variable  a : A.
Variable  b : B.
Local ned := (mkned M (b,a)).

Local f_swapAB :=
 (!ALL(1) x:A | (!EX(0) y:B | (f_p x) !\/ (f_q y)))
  !-> (!EX(0) y:B | (!ALL(1) x:A | (f_p x) !\/ (f_q y))).

Lemma swapAB : (E M L REL f_swapAB).
Proof.
Apply (mcf REL em ac ned f_swapAB).
Time Lazy Beta Delta -[skolT] Iota.
Intro F.

Local f0 := [F:(skolT M)](F (0)(0)(0)((0),(1))).
Local f1 := [F:(skolT M)](F (1)(0)(1)((1),(0))).

Fold (f0 F).
Fold (f1 F).

Intros C1 C2 C3.
Exact ((C1 ((f1 F (b,tt))))(C2 b)(C3 (f0 F (f1 F (b,tt))))).
Qed.


End Sample.


