Require sugarCLAUS.

Section Sample.

Local M := (md1 nat).

Variable P : nat->Prop.

Local L := (ne_cons (1)(sngl (2))).

Local Rel : (relT M L) :=
	[i]<[i:nat](ar_slct M L i)->Prop>
	Cases i of
	  O => P
	| _ => [t] let (n,m)=t in (lt n m)
	end.
(* lt : nat->nat->Prop is already defined in Coq *)

Local f_P  := (f_atom M L (0)).
Local f_lt := [n,m:nat](f_atom M L (1)(n,m)).

Variable em : EM.
Variable ac : AC.
Local ned := (mkned M (0)).

Local serial := (!ALL(0) x:nat | (!EX(0) y:nat | (f_lt x y))).

Local trans :=
 (!ALL(0) x:nat |
  (!ALL(0) y:nat |
   (!ALL(0) z:nat | (f_lt x y) !-> (f_lt y z) !-> (f_lt x z)))).
 
Local chi := 
 (!ALL(0) x:nat |
  (!ALL(0) y:nat | (f_lt x y) !-> !~(f_P y))
   !<-> (f_P x)).

Local theta := serial !/\ trans !-> !~chi.

Theorem Theta : (E M L Rel theta).
Proof.
Apply (mcf Rel em ac ned theta).
Lazy Beta Delta -[skolT lt] Iota.
Intro skol.

(**
The 3rd and 4th clause contain a dummy abstraction (denoted by _).
As we report in our article, this is due to the distribution
of universal quantifiers over clauses, because it is imposssible
to check whether a certain variable has an occurence in a term
p : (prop M L).
As the program coq.pro cannot, as yet, deal with such dummy abstractions,
we first cut the dummy-free version, for which coq.pro generated
the lambda-term below.
Thereafter the current goal (with the dummies)
is easily proved from the dummy-free cut-statement.
**)

(* The following is created by coq.pro           *)

Cut (( CLAUSE_101 : (( qxyx0 : nat ) (( x : ( not ( ( lt qxyx0 ) ( ([ 
x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) ) ) False 
) ) ) (( CLAUSE_102 : (( qxyx0 : nat ) (( qxyz1 : nat ) (( qxyz2 : nat 
) (( z : ( ( lt qxyx0 ) qxyz1 ) ) (( y : ( ( lt qxyz1 ) qxyz2 ) ) (( x 
: ( not ( ( lt qxyx0 ) qxyz2 ) ) ) False ) ) ) ) ) ) ) (( CLAUSE_103 : 
(( qxyx0 : nat ) (( y : ( not ( ( lt qxyx0 ) ( ([ x : nat ] ( ( ( ( ( 
skol (2) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) ) ) (( x : ( not ( P qxyx0 
) ) ) False ) ) ) ) (( CLAUSE_104 : (( qxyx0 : nat ) (( y : ( not ( P 
( ([ x : nat ] ( ( ( ( ( skol (2) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) 
) ) (( x : ( not ( P qxyx0 ) ) ) False ) ) ) ) (( CLAUSE_105 : (( qxyx0 
: nat ) (( qxyz1 : nat ) (( z : ( P qxyx0 ) ) (( y : ( ( lt qxyx0 ) qxyz1 
) ) (( x : ( P qxyz1 ) ) False ) ) ) ) ) ) False ) ) ) ) ) .


2: Exact
([ CLAUSE_100 : (( qxyx0 : nat ) (( x : ( not ( ( lt qxyx0 ) ( (
[ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) ) )
 False ) ) ] ([ CLAUSE_101 : (( qxyx0 : nat ) (( qxyz1 : nat ) (( qxyz2 
: nat ) (( z : ( ( lt qxyx0 ) qxyz1 ) ) (( y : ( ( lt qxyz1 ) qxyz2 ) 
) (( x : ( not ( ( lt qxyx0 ) qxyz2 ) ) ) False ) ) ) ) ) ) ] ([ CLAUSE_102 
: (( qxyx0 : nat ) (( y : ( not ( ( lt qxyx0 ) ( ([ x : nat ] ( ( ( ( 
( skol (2) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) ) ) (( x : ( not ( P qxyx0 
) ) ) False ) ) ) ] ([ CLAUSE_103 : (( qxyx0 : nat ) (( y : ( not ( P 
( ([ x : nat ] ( ( ( ( ( skol (2) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) 
) ) (( x : ( not ( P qxyx0 ) ) ) False ) ) ) ] ([ CLAUSE_104 : (( qxyx0 
: nat ) (( qxyz1 : nat ) (( z : ( P qxyx0 ) ) (( y : ( ( lt qxyx0 ) qxyz1 
) ) (( x : ( P qxyz1 ) ) False ) ) ) ) ) ] ( ([ CLAUSE_105 : (( qxyx0 
: nat ) (( x : ( not ( ( lt qxyx0 ) ( ([ x : nat ] ( ( ( ( ( skol (0) 
) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) ) ) False ) ) ] ( ([ CLAUSE_106 : 
(( qxyx0 : nat ) (( qxyz1 : nat ) (( qxyz2 : nat ) (( z : ( ( lt qxyz1 
) qxyz2 ) ) (( y : ( not ( ( lt qxyx0 ) qxyz2 ) ) ) (( x : ( ( lt qxyx0 
) qxyz1 ) ) False ) ) ) ) ) ) ] ( ([ CLAUSE_107 : (( qxyx0 : nat ) (( 
y : ( not ( P qxyx0 ) ) ) (( x : ( not ( ( lt qxyx0 ) ( ([ x : nat ] (
 ( ( ( ( skol (2) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) ) ) False ) ) ) 
] ( ([ CLAUSE_108 : (( qxyx0 : nat ) (( y : ( not ( P ( ([ x : nat ] (
 ( ( ( ( skol (2) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) ) ) (( x : ( not 
( P qxyx0 ) ) ) False ) ) ) ] ( ([ CLAUSE_109 : (( qxyx0 : nat ) (( qxyz1 
: nat ) (( z : ( P qxyx0 ) ) (( y : ( P qxyz1 ) ) (( x : ( ( lt qxyx0 
) qxyz1 ) ) False ) ) ) ) ) ] ( ([ CLAUSE_110 : (( qxyx0 : nat ) (( qxyz1 
: nat ) (( y : ( not ( ( lt qxyz1 ) ( ([ x : nat ] ( ( ( ( ( skol (0) 
) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) ) ) (( x : ( ( lt qxyz1 ) qxyx0 ) 
) False ) ) ) ) ] ( ([ CLAUSE_111 : (( qxyx0 : nat ) (( qxyz1 : nat ) 
(( y : ( not ( ( lt qxyx0 ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) 
(0) ) (1) ) x ) ) qxyz1 ) ) ) ) (( x : ( ( lt qxyx0 ) qxyz1 ) ) False 
) ) ) ) ] ( ([ CLAUSE_112 : (( qxyx0 : nat ) (( qxyz1 : nat ) (( qxyz2 
: nat ) (( t : ( P qxyx0 ) ) (( z : ( P qxyz1 ) ) (( y : ( ( lt qxyz2 
) qxyz1 ) ) (( x : ( ( lt qxyx0 ) qxyz2 ) ) False ) ) ) ) ) ) ) ] ( ([ 
CLAUSE_113 : (( qxyx0 : nat ) (( qxyz1 : nat ) (( qxyz2 : nat ) (( t : 
( P qxyx0 ) ) (( z : ( P qxyz1 ) ) (( y : ( ( lt qxyx0 ) qxyz2 ) ) (( 
x : ( ( lt qxyz2 ) qxyz1 ) ) False ) ) ) ) ) ) ) ] ( ([ CLAUSE_114 : (
( qxyx0 : nat ) (( x : ( not ( ( lt qxyx0 ) ( ([ x : nat ] ( ( ( ( ( skol 
(0) ) (0) ) (0) ) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) 
) (0) ) (1) ) x ) ) qxyx0 ) ) ) ) ) False ) ) ] ( ([ CLAUSE_115 : (( qxyx0 
: nat ) (( x : ( not ( ( lt qxyx0 ) ( ([ x : nat ] ( ( ( ( ( skol (0) 
) (0) ) (0) ) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0)
 ) (1) ) x ) ) qxyx0 ) ) ) ) ) False ) ) ] ( ([ CLAUSE_116 : (( qxyx0 
: nat ) (( x : ( not ( ( lt qxyx0 ) ( ([ x : nat ] ( ( ( ( ( skol (0) 
) (0) ) (0) ) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0)
 ) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x 
) ) qxyx0 ) ) ) ) ) ) False ) ) ] ( ([ CLAUSE_117 : (( qxyx0 : nat ) (
( x : ( not ( ( lt qxyx0 ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (
0) ) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) )
 x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) qxyx0 
) ) ) ) ) ) False ) ) ] ( ([ CLAUSE_118 : (( qxyx0 : nat ) (( y : ( P 
qxyx0 ) ) (( x : ( P ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (
1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) )
 ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) )
 ) ) ) False ) ) ) ] ( ([ CLAUSE_119 : (( qxyx0 : nat ) (( y : ( P ( (
[ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) ( ([ x : nat 
] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( 
( skol (0) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) ) ) ) (( x : ( P qxyx0 
) ) False ) ) ) ] ( ([ CLAUSE_120 : (( qxyx0 : nat ) (( qxyz1 : nat ) 
(( t : ( P qxyx0 ) ) (( z : ( P ( ([ x : nat ] ( ( ( ( ( skol (2) ) (0)
 ) (0) ) (1) ) x ) ) qxyz1 ) ) ) (( y : ( ( lt qxyx0 ) qxyz1 ) ) (( x 
: ( not ( P qxyz1 ) ) ) False ) ) ) ) ) ) ] ( ([ CLAUSE_121 : (( qxyx0 
: nat ) (( qxyz1 : nat ) (( t : ( P qxyx0 ) ) (( z : ( ( lt qxyx0 ) qxyz1 
) ) (( y : ( not ( P qxyz1 ) ) ) (( x : ( not ( P qxyz1 ) ) ) False ) 
) ) ) ) ) ] ( ([ CLAUSE_122 : (( qxyx0 : nat ) (( qxyz1 : nat ) (( z : 
( P qxyx0 ) ) (( y : ( ( lt qxyx0 ) qxyz1 ) ) (( x : ( not ( P qxyz1 )
 ) ) False ) ) ) ) ) ] ( ([ CLAUSE_123 : (( qxyx0 : nat ) (( qxyz1 : nat 
) (( z : ( P qxyx0 ) ) (( y : ( not ( P qxyz1 ) ) ) (( x : ( ( lt qxyx0 
) qxyz1 ) ) False ) ) ) ) ) ] ( ([ CLAUSE_124 : (( qxyx0 : nat ) (( y 
: ( P qxyx0 ) ) (( x : ( not ( P ( ([ x : nat ] ( ( ( ( ( skol (0) ) (
0) ) (0) ) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) )
 (1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x )
 ) qxyx0 ) ) ) ) ) ) False ) ) ) ] ( ([ CLAUSE_125 : (( qxyx0 : nat ) 
(( y : ( P qxyx0 ) ) (( x : ( P qxyx0 ) ) False ) ) ) ] ( ([ CLAUSE_126 
: (( qxyx0 : nat ) (( x : ( P qxyx0 ) ) False ) ) ] ( ([ CLAUSE_127 : 
(( qxyx0 : nat ) (( x : ( P qxyx0 ) ) False ) ) ] ( ([ CLAUSE_128 : ((
 qxyx0 : nat ) (( x : ( not ( P qxyx0 ) ) ) False ) ) ] ( ( CLAUSE_128 
O ) ([ x : ( P O ) ] ( ( CLAUSE_127 O ) x ) ) ) ) ([ qxyx0 : nat ] ([ 
x : ( not ( P qxyx0 ) ) ] ( ( ( CLAUSE_108 qxyx0 ) ([ y : ( P ( ([ x : 
nat ] ( ( ( ( ( skol (2) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) ] ( ( CLAUSE_127 
( ([ x : nat ] ( ( ( ( ( skol (2) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) 
y ) ) ) x ) ) ) ) ) ([ qxyx0 : nat ] ([ x : ( P qxyx0 ) ] ( ( CLAUSE_126 
qxyx0 ) x ) ) ) ) ) ([ qxyx0 : nat ] ([ x : ( P qxyx0 ) ] ( ( ( CLAUSE_125 
qxyx0 ) x ) x ) ) ) ) ) ([ qxyx0 : nat ] ([ y : ( P qxyx0 ) ] ([ x : (
 P qxyx0 ) ] ( ( ( CLAUSE_124 qxyx0 ) x ) ([ z : ( P ( ([ x : nat ] ( 
( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol 
(0) ) (0) ) (0) ) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) 
) (0) ) (1) ) x ) ) qxyx0 ) ) ) ) ] ( ( ( CLAUSE_119 qxyx0 ) z ) x ) )
 ) ) ) ) ) ) ([ qxyx0 : nat ] ([ y : ( P qxyx0 ) ] ([ x : ( not ( P ( 
([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) ( ([ x : nat 
] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( 
( skol (0) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) ) ) ) ] ( ( CLAUSE_117 
qxyx0 ) ([ z : ( ( lt qxyx0 ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) 
) (0) ) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1)
 ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) qxyx0 
) ) ) ) ] ( ( ( ( ( CLAUSE_123 qxyx0 ) ( ([ x : nat ] ( ( ( ( ( skol (
0) ) (0) ) (0) ) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) )
 (0) ) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1)
 ) x ) ) qxyx0 ) ) ) ) y ) x ) z ) ) ) ) ) ) ) ) ([ qxyx0 : nat ] ([ qxyz1 
: nat ] ([ z : ( P qxyx0 ) ] ([ y : ( not ( P qxyz1 ) ) ] ([ x : ( ( lt 
qxyx0 ) qxyz1 ) ] ( ( ( ( ( CLAUSE_122 qxyx0 ) qxyz1 ) z ) x ) y ) ) )
 ) ) ) ) ) ([ qxyx0 : nat ] ([ qxyz1 : nat ] ([ z : ( P qxyx0 ) ] ([ y 
: ( ( lt qxyx0 ) qxyz1 ) ] ([ x : ( not ( P qxyz1 ) ) ] ( ( ( ( ( ( CLAUSE_121 
qxyx0 ) qxyz1 ) z ) y ) x ) x ) ) ) ) ) ) ) ) ([ qxyx0 : nat ] ([ qxyz1 
: nat ] ([ t : ( P qxyx0 ) ] ([ z : ( ( lt qxyx0 ) qxyz1 ) ] ([ y : ( 
not ( P qxyz1 ) ) ] ([ x : ( not ( P qxyz1 ) ) ] ( ( ( CLAUSE_108 qxyz1 
) ([ u : ( P ( ([ x : nat ] ( ( ( ( ( skol (2) ) (0) ) (0) ) (1) ) x )
 ) qxyz1 ) ) ] ( ( ( ( ( ( CLAUSE_120 qxyx0 ) qxyz1 ) t ) u ) z ) x ) 
) ) x ) ) ) ) ) ) ) ) ) ([ qxyx0 : nat ] ([ qxyz1 : nat ] ([ t : ( P qxyx0 
) ] ([ z : ( P ( ([ x : nat ] ( ( ( ( ( skol (2) ) (0) ) (0) ) (1) ) x 
) ) qxyz1 ) ) ] ([ y : ( ( lt qxyx0 ) qxyz1 ) ] ([ x : ( not ( P qxyz1 
) ) ] ( ( ( CLAUSE_107 qxyz1 ) x ) ([ u : ( ( lt qxyz1 ) ( ([ x : nat 
] ( ( ( ( ( skol (2) ) (0) ) (0) ) (1) ) x ) ) qxyz1 ) ) ] ( ( ( ( ( (
 ( CLAUSE_113 qxyx0 ) ( ([ x : nat ] ( ( ( ( ( skol (2) ) (0) ) (0) ) 
(1) ) x ) ) qxyz1 ) ) qxyz1 ) t ) z ) y ) u ) ) ) ) ) ) ) ) ) ) ) ([ qxyx0 
: nat ] ([ y : ( P ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1)
 ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) (
 ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) )
 ) ] ([ x : ( P qxyx0 ) ] ( ( ( CLAUSE_118 qxyx0 ) x ) y ) ) ) ) ) ) (
[ qxyx0 : nat ] ([ y : ( P qxyx0 ) ] ([ x : ( P ( ([ x : nat ] ( ( ( (
 ( skol (0) ) (0) ) (0) ) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0)
 ) (0) ) (0) ) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (
0) ) (1) ) x ) ) qxyx0 ) ) ) ) ] ( ( CLAUSE_117 qxyx0 ) ([ z : ( ( lt 
qxyx0 ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) ( 
([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) ( ([ x : nat 
] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) ) ) ] ( ( ( (
 ( CLAUSE_109 qxyx0 ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) 
(1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) 
) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) 
) ) ) y ) x ) z ) ) ) ) ) ) ) ) ([ qxyx0 : nat ] ([ x : ( not ( ( lt qxyx0 
) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) ( ([ x : 
nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) ( ([ x : nat ] ( ( 
( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) ) ) ) ] ( ( CLAUSE_116 
qxyx0 ) x ) ) ) ) ) ([ qxyx0 : nat ] ([ x : ( not ( ( lt qxyx0 ) ( ([ 
x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) ( ([ x : nat ] 
( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( 
skol (0) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) ) ) ) ] ( ( CLAUSE_115 qxyx0 
) ([ y : ( ( lt qxyx0 ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) 
) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x 
) ) qxyx0 ) ) ) ] ( ( ( ( CLAUSE_111 qxyx0 ) ( ([ x : nat ] ( ( ( ( ( 
skol (0) ) (0) ) (0) ) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) )
 (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) ) x ) y ) ) ) ) ) ) ) ([ qxyx0 : nat 
] ([ x : ( not ( ( lt qxyx0 ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) 
) (0) ) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1)
 ) x ) ) qxyx0 ) ) ) ) ] ( ( CLAUSE_114 qxyx0 ) x ) ) ) ) ) ([ qxyx0 : 
nat ] ([ x : ( not ( ( lt qxyx0 ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) 
(0) ) (0) ) (1) ) x ) ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) 
) (1) ) x ) ) qxyx0 ) ) ) ) ] ( ( CLAUSE_105 qxyx0 ) ([ y : ( ( lt qxyx0 
) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) 
) ] ( ( ( ( CLAUSE_111 qxyx0 ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0)
 ) (0) ) (1) ) x ) ) qxyx0 ) ) x ) y ) ) ) ) ) ) ) ([ qxyx0 : nat ] ([ 
qxyz1 : nat ] ([ qxyz2 : nat ] ([ t : ( P qxyx0 ) ] ([ z : ( P qxyz1 )
 ] ([ y : ( ( lt qxyx0 ) qxyz2 ) ] ([ x : ( ( lt qxyz2 ) qxyz1 ) ] ( (
 ( ( ( ( ( CLAUSE_112 qxyx0 ) qxyz1 ) qxyz2 ) t ) z ) x ) y ) ) ) ) ) 
) ) ) ) ) ([ qxyx0 : nat ] ([ qxyz1 : nat ] ([ qxyz2 : nat ] ([ t : ( 
P qxyx0 ) ] ([ z : ( P qxyz1 ) ] ([ y : ( ( lt qxyz2 ) qxyz1 ) ] ([ x 
: ( ( lt qxyx0 ) qxyz2 ) ] ( ( ( ( ( ( CLAUSE_106 qxyx0 ) qxyz2 ) qxyz1 
) y ) ([ u : ( ( lt qxyx0 ) qxyz1 ) ] ( ( ( ( ( CLAUSE_109 qxyx0 ) qxyz1 
) t ) z ) u ) ) ) x ) ) ) ) ) ) ) ) ) ) ([ qxyx0 : nat ] ([ qxyz1 : nat 
] ([ y : ( not ( ( lt qxyx0 ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) 
) (0) ) (1) ) x ) ) qxyz1 ) ) ) ] ([ x : ( ( lt qxyx0 ) qxyz1 ) ] ( ( 
( ( CLAUSE_110 qxyz1 ) qxyx0 ) y ) x ) ) ) ) ) ) ) ([ qxyx0 : nat ] ([ 
qxyz1 : nat ] ([ y : ( not ( ( lt qxyz1 ) ( ([ x : nat ] ( ( ( ( ( skol 
(0) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) ) ] ([ x : ( ( lt qxyz1 ) qxyx0 
) ] ( ( CLAUSE_105 qxyx0 ) ([ z : ( ( lt qxyx0 ) ( ([ x : nat ] ( ( ( 
( ( skol (0) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) ] ( ( ( ( ( ( CLAUSE_106 
qxyz1 ) qxyx0 ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) 
x ) ) qxyx0 ) ) z ) y ) x ) ) ) ) ) ) ) ) ) ([ qxyx0 : nat ] ([ qxyz1 
: nat ] ([ z : ( P qxyx0 ) ] ([ y : ( P qxyz1 ) ] ([ x : ( ( lt qxyx0 
) qxyz1 ) ] ( ( ( ( ( CLAUSE_104 qxyx0 ) qxyz1 ) z ) x ) y ) ) ) ) ) )
 ) ) ([ qxyx0 : nat ] ([ y : ( not ( P ( ([ x : nat ] ( ( ( ( ( skol (
2) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) ) ] ([ x : ( not ( P qxyx0 ) ) 
] ( ( ( CLAUSE_103 qxyx0 ) y ) x ) ) ) ) ) ) ([ qxyx0 : nat ] ([ y : (
 not ( P qxyx0 ) ) ] ([ x : ( not ( ( lt qxyx0 ) ( ([ x : nat ] ( ( ( 
( ( skol (2) ) (0) ) (0) ) (1) ) x ) ) qxyx0 ) ) ) ] ( ( ( CLAUSE_102 
qxyx0 ) x ) y ) ) ) ) ) ) ([ qxyx0 : nat ] ([ qxyz1 : nat ] ([ qxyz2 : 
nat ] ([ z : ( ( lt qxyz1 ) qxyz2 ) ] ([ y : ( not ( ( lt qxyx0 ) qxyz2 
) ) ] ([ x : ( ( lt qxyx0 ) qxyz1 ) ] ( ( ( ( ( ( CLAUSE_101 qxyx0 ) qxyz1 
) qxyz2 ) x ) z ) y ) ) ) ) ) ) ) ) ) ([ qxyx0 : nat ] ([ x : ( not ( 
( lt qxyx0 ) ( ([ x : nat ] ( ( ( ( ( skol (0) ) (0) ) (0) ) (1) ) x )
 ) qxyx0 ) ) ) ] ( ( CLAUSE_100 qxyx0 ) x ) ) ) ) ) ) ) ) ) .


(* The following was created by hand; see previous note.   *) 

Exact [cs;h0;h1;h2;h3;h4](cs h0 h1 [n](h2 n O) [n](h3 n O) h4).

Save.


End Sample.
