Require Export axiom_types.

Section cnf_thms.

Variable M : MD.
Variable N : (etL M).
Variable R : (relT M N).
Local prp := (prop M N).
Local iE := (E M N R).
Variable ned:(NED M).

Lemma distr_r_lem1 : (p,q:prp)(iE p)\/(iE q)->(iE (distr_r M N p q)).
Proof.
Intros p q. Elim q; Auto.
(* AND *)
Intros q1 IH1 q2 IH2 H.
Elim H; Intro H0; Split.
Apply IH1. Left. Exact H0.
Apply IH2. Left. Exact H0.
Apply IH1. Right. Exact (proj1 ? ? H0).
Apply IH2. Right. Exact (proj2 ? ? H0).
Qed.

Lemma distr_lem1 : (p,q:prp)(iE p)\/(iE q)->(iE (distr M N p q)).
Proof.
Induction p.
Intros i a. Exact (distr_r_lem1 (f_Atom i a)).
Intros p0 IH. Exact (distr_r_lem1 (f_Not p0)).
(* AND *)
Intros p1 IH1 p2 IH2 q H.
Elim H; Intro H0; Split.
Apply IH1. Left. Exact (proj1 ? ? H0).
Apply IH2. Left. Exact (proj2 ? ? H0).
Apply IH1. Right. Exact H0.
Apply IH2. Right. Exact H0. (* DNA *)
Intros p1 IH1 p2 IH2. Exact (distr_r_lem1 (f_Or p1 p2)).
Intros p1 IH1 p2 IH2. Exact (distr_r_lem1 (f_Impl p1 p2)).
Intros k dp IH. Exact (distr_r_lem1 (f_Ex k dp)).
Intros k dp IH. Exact (distr_r_lem1 (f_All k dp)).
Qed.

Theorem cnf_thm1 : (p:prp)(iE p)->(iE (cnf M N p)).
Proof.
Induction p; Auto.
(* AND *)
Intros p1 IH1 p2 IH2 H.
Elim H; Intros H1 H2.
Split. Exact (IH1 H1). Exact (IH2 H2).
(* OR *)
Intros p1 IH1 p2 IH2 H.
Apply (distr_lem1 (cnf M N p1)(cnf M N p2)).
Elim H; Intro H0.
Left. Exact (IH1 H0).
Right. Exact (IH2 H0).
(* EX *)
Intros k dp IH H.
Elim H.
Intros x H0.
Split with x.
Exact (IH x H0).
(* ALL *)
Simpl. Intros k dp IH H x.
Exact (IH x (H x)).
Qed.

End cnf_thms.
