Implicit Arguments On.

Section NonEmptyLists.

Variable A:Set.

Inductive ne_list : Set :=
     sngl : A->ne_list
| ne_cons : A->ne_list->ne_list.

Fixpoint ne_app [L1:ne_list] : ne_list->ne_list :=
[L2]Cases L1 of
 (sngl a)      => (ne_cons a L2) 
|(ne_cons a t) => (ne_cons a (ne_app t L2))
end.

Fixpoint ne_nth [L:ne_list] : nat->A :=
[n] Cases L of
 (sngl a)      => a
|(ne_cons a t) => Cases n of
                    O     => a
                  |(S n') => (ne_nth t n')
                  end
end.
End NonEmptyLists.

Implicit Arguments Off.
