Require Export insert.
Require Export axiom_types.

Section SkolemTheoremSupport.

Definition fst_elt' := [s:Set;e:nat]
<[e:nat](pow' s e)->s>
Cases e of
   O     => (id s)
| (S e') => [selts:s*(pow' s e')]let (x,selts')=selts in x
end.

Definition fst_elt := [s:Set;d:s;e:nat]
<[e:nat](pow s e)->s>
Cases e of
   O     => [_:unit]d
| (S e') => (fst_elt' s e')
end.

Fixpoint nth_fst_elt [M:MD;n:nat] : (Dslct n M)->(z:(etT M))(sar M z)
								->(Dslct n M) :=
<[M:MD](Dslct n M)->(z:(etT M))(sar M z)->(Dslct n M)>
Cases M of
  ((md1 s) as m1)   =>
 <[n:nat](Dslct n m1)->(e:nat)(pow s e)->(Dslct n m1)>
 Cases n of
    O     => (fst_elt s)
 | (S n') => [d:unit;e:nat;_:(pow s e)]d
 end
| ((md2 s m) as m2) =>
 <[n:nat](Dslct n m2)->(z:nat*(etT m))(sar m2 z)->(Dslct n m2)>
 Cases n of
    O     => [d:s;z:nat*(etT m)]
	     <[z:nat*(etT m)](sar m2 z)->s>
	     let (e,z')=z in
	     <[e:nat](sar m2 (e,z'))->s>
	     Cases e of
	        O     => [_:(sar m z')]d
	     | (S e') => [uqs:(pow' s e')*(sar m z')]
			 let (suqs,_)=uqs in (fst_elt' s e' suqs)
	     end
 | (S n') => [d:(Dslct n' m);z:nat*(etT m)]
	     <[z:nat*(etT m)](sar m2 z)->(Dslct n' m)>
	     let (e,z')=z in
	     <[e:nat](sar m2 (e,z'))->(Dslct n' m)>
	     Cases e of
	        O     => (nth_fst_elt m n' d z')
	     | (S e') => [uqs:(pow' s e')*(sar m z')]
			 let (_,muqs)=uqs in (nth_fst_elt m n' d z' muqs)
	     end
 end
end.

Definition rm_fst_elt' := [s:Set;e:nat;selts:s*(pow' s e)]
let (_,selts')=selts in selts'.

Definition rm_fst_elt := [s:Set;e:nat]
<[e:nat](pow' s e)->(pow s e)>
Cases e of
   O     => [_:s]tt
| (S e') => (rm_fst_elt' s e')
end.

Fixpoint rm_nth_fst_elt [M:MD] : (n:nat)(z:(etT M))(sar M z)
					->(sar M (pred_nth_exp M n z)) :=
<[M:MD](n:nat)(z:(etT M))(sar M z)->(sar M (pred_nth_exp M n z))>
Cases M of
  ((md1 s) as m1)   => [n:nat]
 <[n:nat](e:nat)(pow s e)->(pow s (pred_nth_exp m1 n e))>
 Cases n of
    O     => [e:nat]
	     <[e:nat](pow s e)->(pow s (pred e))>
	     Cases e of
	        O     => (id unit)
	     | (S e') => (rm_fst_elt s e')
	     end
 | (S n') => [e:nat](id (pow s e))
 end
| ((md2 s m) as m2) => [n:nat]
 <[n:nat](z:nat*(etT m))(sar m2 z)->(sar m2 (pred_nth_exp m2 n z))>
 Cases n of
    O     => [z:nat*(etT m)]
	     <[z:nat*(etT m)](sar m2 z)->(sar m2 (pred_nth_exp m2 O z))>
	     let (e,z')=z in
	     <[e:nat](sar m2 (e,z'))->(sar m2 (pred_nth_exp m2 O (e,z')))>
	     Cases e of
	        O     => (id (sar m z'))
	     | (S e') => <[e':nat](pow' s e')*(sar m z')->(sar m2 (e',z'))>
			 Cases e' of
			    O      => [uqs:s*(sar m z')]
				      let (_,muqs)=uqs in muqs
			 | (S e'') => [uqs:(s*(pow' s e''))*(sar m z')]
				      let (suqs,muqs)=uqs in
				      ((rm_fst_elt' s e'' suqs),muqs)
			 end
	     end
 | (S n') => [z:nat*(etT m)]
	     <[z:nat*(etT m)](sar m2 z)->(sar m2 (pred_nth_exp m2 (S n') z))>
	     let (e,z')=z in
	     <[e:nat](sar m2 (e,z'))->(sar m2 (e,(pred_nth_exp m n' z')))>
	     Cases e of
	        O     => (rm_nth_fst_elt m n' z')
	     | (S e') => [uqs:(pow' s e')*(sar m z')]
			 let (suqs,muqs)=uqs in
			 (suqs,(rm_nth_fst_elt m n' z' muqs))
	     end
 end
end.

Fixpoint x_if_eqab [M:MD] : (ned:(NED M);a,b:nat)(Dslct b M)->(Dslct a M) :=
<[M:MD]((n:nat)(Dslct n M))->(a,b:nat)(Dslct b M)->(Dslct a M)>
Cases M of
  ((md1 s) as m1)   =>
		[ned:(NED m1);a,b:nat]
		<[a:nat](Dslct b m1)->(Dslct a m1)>
		Cases a of
		  O     => <[b:nat](Dslct b m1)->s>
			   Cases b of
			      O     => [x:s]x
   			   | (S b') => [_:unit](ned O) end
	       | (S a') => [_:(Dslct b m1)]tt end
| ((md2 s m) as m2) =>
		[ned:(NED m2);a,b:nat]
		<[a:nat](Dslct b m2)->(Dslct a m2)>
		Cases a of
		   O     => <[b:nat](Dslct b m2)->s>
			    Cases b of
			       O     => [x:s]x
			    | (S b') => [_:(Dslct b' m)](ned O) end
		| (S a') => <[b:nat](Dslct b m2)->(Dslct a' m)>
			    Cases b of
			       O     => [_:s](ned (S a'))
			    | (S b') => (x_if_eqab m [k:nat](ned (S k)) a' b')
			    end
	       end
end.

End SkolemTheoremSupport.
