Require Export sklm_lems.

Section SkolemizationTheorems.

Variable M : MD.
Variable N : (etL M).
Variable REL : (relT M N).
Local prp := (prop M N).
Variable ned:(NED M).
Variable ac:AC.

Local dumskol := [_,_,k:nat;z:(etT M);_:(sar M z)](ned k).

Lemma sklm_thm1 :
(i:nat;p:prp)
 (iE REL p)
 ->(EX skol:(skolT M)|(iE REL (sklm M N skol i p))).
Proof.
Intros i p.
Elim p; Simpl.
(* ATOM *)
Intros x t H.
Exists dumskol.
Exact H.
(* NOT *)
Intros p0 IH H.
Exists dumskol.
Red. Intro H0. Apply H.
Exact H0.
(* AND *)
Intros p1 IH1 p2 IH2 H.
Exists dumskol.
Elim H. Intros H1 H2. Split.
Exact H1.
Exact H2.
(* OR *)
Intros p1 IH1 p2 IH2 H.
Exists dumskol.
Elim H; Intro H0.
Left. Exact H0.
Right. Exact H0.
(* IMPL *)
Intros p1 IH1 p2 IH2 H.
Exists dumskol.
Exact H.
(* EX *)
Intros k dp IH H.
Elim H. Intros x H0.
Elim (IH x H0).
Intros f H1.
Exists [i,j:nat] Cases j of
	           O     => [m:nat;z:(etT M);_:(sar M z)]
			    (x_if_eqab M ned m k x)
	        | (S j') => (f i j') end.
Unfold sklm. Simpl.
Replace (x_if_eqab M ned k k x) with x.
Apply
 (sklm_eeqfg M N REL f
  [i,j:nat] Cases j of
	     O     => [m:nat;z:(etT M);_:(sar M z)](x_if_eqab M ned m k x)
	  | (S j') => (f i j') end
   (dp x) i (0)(1)(zeroes M)(zeroes M)(mktt M)(mktt M)).
Trivial with v62.
Exact H1.
Apply x_if_eqab_corr.
(* ALL *)
Intros k dp IH H.
Elim
 (ac M N REL k
  [x:(Dslct k M);f:(skolT M)](sklm M N f i (dp x))).
Intros F H0.
Exists
 [i,j,m:nat;z:(etT M);elts:(sar M z)]
  (F (nth_fst_elt M k (ned k) z elts)
      i j m (pred_nth_exp M k z)(rm_nth_fst_elt M k z elts)).
Intro x.
Apply (sklm_eeqfg M N REL (F x)
	[i,j,m:nat;z:(etT M);elts:(sar M z)]
	(F (nth_fst_elt M k (ned k) z elts)
	i j m (pred_nth_exp M k z)(rm_nth_fst_elt M k z elts))
	(dp x) i (0)(0)(zeroes M)(S_nth_exp M k (zeroes M))
	(mktt M)(insertb M k x (zeroes M)(mktt M))).
Intros a b z elts.
Replace (nth_fst_elt M k (ned k)
          (etplus M (S_nth_exp M k (zeroes M)) z)
          (insertf_tuple M (S_nth_exp M k (zeroes M))
            (insertb M k x (zeroes M)(mktt M)) z elts)) with x.
Apply
 (proj1 ? ?
  (beq5 M z elts
   [u:(etT M);uelts:(sar M u)]
    (F x i a b (etplus M (zeroes M) z)(insertf_tuple M (zeroes M)(mktt M) z elts))
     = (F x i a b u uelts) k x)).
Apply (proj1 ? ?
        (beq1 M z elts
          [u:(etT M)][uelts:(sar M u)](F x i a b u uelts)=(F x i a b z elts))).
Reflexivity.
Symmetry. Exact (nfu0 M z elts k (ned k) x).
Exact (H0 x).
Intro x.
Elim (IH x (H x)).
Intros f H0.
Exists f.
Exact H0.
Qed.

Theorem sklm_thm2 : (i:nat;p:prp)
  (EX skol:(skolT M)|(iE REL (sklm M N skol i p)))->(iE REL p).
Proof.
Intros i p.
Elim p; Simpl.
(* ATOM *)
Intros x t H.
Elim H.
Trivial.
(* NOT *)
Red. Intros p0 IH H H0.
Elim H. Intros f H1. Apply H1.
Exact H0.
(* AND *)
Intros p1 IH1 p2 IH2 H.
Elim H. Intros f H0.
Elim H0. Intros H1 H2.
Split.
Exact H1.
Exact  H2.
(* OR *)
Intros p1 IH1 p2 IH2 H.
Elim H. Intros f H0.
Elim H0; Intro H1.
Left. Exact H1.
Right. Exact H1.
(* IMPL *)
Intros p1 IH1 p2 IH2 H H0.
Elim H. Intros f H1.
Exact (H1 H0).
(* EX *)
Intros k dp IH H.
Elim H.
Intros f H0.
Exists (f i (0) k (zeroes M)(mktt M)).
Apply (IH (f i (0) k (zeroes M)(mktt M))).
Exists [i,j:nat](f i (S j)).
Apply (sklm_eeqfg M N REL f [i,j:nat](f i (S j))
        (dp (f i (0) k (zeroes M) (mktt M)))
	i (1)(0)(zeroes M)(zeroes M)(mktt M)(mktt M)).
Trivial.
Exact H0.
(* ALL *)
Intros k dp IH H x.
Elim H. Intros f H0.
Apply (IH x).
Exists [i,j,m:nat;z:(etT M);elts:(sar M z)]
	(f i j m (S_nth_exp M k z)(insertf M k x z elts)).
Apply (sklm_eeqfg M N REL f
	[i,j,m:nat;z:(etT M);elts:(sar M z)]
	 (f i j m (S_nth_exp M k z)(insertf M k x z elts))
	(dp x) i (0)(0)(S_nth_exp M k (zeroes M))(zeroes M)
        (insertb M k x (zeroes M)(mktt M))(mktt M)).
Intros m n z elts.
Apply
 (proj1 ? ?
  (beq4 M k x z elts
   [u:(etT M);bb:(sar M u)]
    (f i m n (etplus M (S_nth_exp M k (zeroes M)) z)
     (insertf_tuple M (S_nth_exp M k (zeroes M))
       (insertb M k x (zeroes M) (mktt M)) z elts))
    =(f i m n u bb))).
Reflexivity.
Exact (H0 x).
Qed.

End SkolemizationTheorems.
